//+------------------------------------------------------------------+
//|                                         VoltyChannel_Stop_v2.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property indicator_color3 LawnGreen
#property indicator_color4 Red
#property indicator_width3 1
#property indicator_width4 1




extern int     Price          = 0; //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int     NemaLength     = 3; //MA's Period 
extern int     NemaDepth      = 10;
extern int     ATR_Length     = 4; //ATR's Period
extern double  Kv             = 0; //Volatility's Factor or Multiplier
extern double  MoneyRisk      = 1; //Offset Factor 
extern int     VisualMode     = 1; //0-lines,1-dots 

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 


double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[];
double smin[];
double smax[];
double trend[];


  int init()
  {
   
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,UpSignal);
   SetIndexBuffer(3,DnSignal);
   SetIndexBuffer(4,smin);
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   
   if(VisualMode==0)
   {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   }
   else
   {
   SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
   }
   SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
   SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
   
   IndicatorShortName("VoltyChannel_Stop("+NemaLength+","+ATR_Length+","+DoubleToStr(Kv,3)+")");
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   SetIndexLabel(2,"UpSignal");
   SetIndexLabel(3,"DnSignal");

   return(0);
  }

//+------------------------------------------------------------------+
//| VoltyChannel_Stop_2                                              |
//+------------------------------------------------------------------+
int start()
  {
   
   int counted_bars=IndicatorCounted();
   int shift,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
     
	   for(shift=limit;shift>=0;shift--) 
      {	
      if(Price==2 || Price==3)
      {
      double bprice = iNema(iMA(NULL,0,200,0,MODE_EMA,PRICE_HIGH,shift),NemaLength,NemaDepth,shift,0);
      double sprice = iNema(iMA(NULL,0,200,0,MODE_EMA,PRICE_LOW, shift),NemaLength,NemaDepth,shift,1);
      }
      else
      {
      bprice = iNema(iMA(NULL,0,200,0,MODE_EMA,Price,shift),NemaLength,NemaDepth,shift,0);
      sprice = iNema(iMA(NULL,0,200,0,MODE_EMA,Price,shift),NemaLength,NemaDepth,shift,1);
      }
       
   smin[shift] = sprice - Kv*iATR(NULL,0,ATR_Length,shift); 
	smax[shift] = bprice + Kv*iATR(NULL,0,ATR_Length,shift);
	
   trend[shift]=trend[shift+1];
   if ( bprice > smax[shift+1] ) trend[shift] =  1;
   if ( sprice < smin[shift+1] ) trend[shift] = -1;
	
      if ( trend[shift] >0 ) 
	   {
	   if( smin[shift] < smin[shift+1]) smin[shift] = smin[shift+1];
	   UpBuffer[shift] = smin[shift] - (MoneyRisk - 1)*iATR(NULL,0,ATR_Length,shift);
	   if( UpBuffer[shift] < UpBuffer[shift+1] && UpBuffer[shift+1]!=EMPTY_VALUE) UpBuffer[shift] = UpBuffer[shift+1];
	   if(trend[shift+1] != trend[shift]) UpSignal[shift] = UpBuffer[shift];
	   else UpSignal[shift] = EMPTY_VALUE;
	   DnBuffer[shift] = EMPTY_VALUE;
	   DnSignal[shift] = EMPTY_VALUE;
	   }
	   else
	   if ( trend[shift] <0 ) 
	   {
	   if( smax[shift]>smax[shift+1]) smax[shift] = smax[shift+1];
	   DnBuffer[shift] = smax[shift] + (MoneyRisk - 1)*iATR(NULL,0,ATR_Length,shift);
	   if( DnBuffer[shift] > DnBuffer[shift+1]) DnBuffer[shift] = DnBuffer[shift+1];
	   if(trend[shift+1] != trend[shift]) DnSignal[shift] = DnBuffer[shift];
	   else DnSignal[shift] = EMPTY_VALUE;
	   UpBuffer[shift] = EMPTY_VALUE;
	   UpSignal[shift] = EMPTY_VALUE;
	   }
      }
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}





void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Volty channel trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Volty channel "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][50][2];
double coeffs[][2];
double depths[];

double iNema(double price, double period, int depth, int r, int forValue)
{
   double alpha  = 2.0/(1.0+period);
   double result = 0;
   double sign   = 1;

   if (ArrayRange(work,0)!=Bars)   ArrayResize(work,Bars);
   if (ArraySize(depths)<forValue) ArrayResize(depths,Bars);
   if (depths[forValue] != depth)
   {
      int size = ArrayRange(coeffs,0);
         if (size < depth) ArrayResize(coeffs,depth+1);
         for(int k=0; k<=depth; k++) coeffs[k][forValue] = factorial(depth)/(factorial(depth-k)*factorial(k));
                                     depths[forValue]    = depth;
   }
   
   //
   //
   //
   //
   //

   r = Bars-r-1;   
   for (k=0; k<depth; k++, sign *= -1)
   {
      if (r<2)
            work[r][k][forValue] = price;
      else  work[r][k][forValue] = work[r-1][k][forValue]+alpha*(price-work[r-1][k][forValue]);
      price  = work[r][k][forValue];
      result += price*sign*coeffs[k+1][forValue];
   }
   return(result);               
}

//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}